# -*- coding: utf-8 -*-
"""
/***************************************************************************
 oso_plugin_qgisDialog
                                 A QGIS plugin
 test plugin
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                             -------------------
        begin                : 2019-12-31
        git sha              : $Format:%H$
        copyright            : (C) 2019 by oso
        email                : oso@oso.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

import os

from qgis.PyQt import uic
from qgis.PyQt import QtWidgets
from qgis.utils import iface

# This loads your .ui file so that PyQt can populate your plugin with the elements from Qt Designer
FORM_CLASS, _ = uic.loadUiType(os.path.join(
    os.path.dirname(__file__), 'oso_plugin_qgis_dialog_base.ui'))


class oso_plugin_qgisDialog(QtWidgets.QDialog, FORM_CLASS):
    def __init__(self, parent=None):
        """Constructor."""
        super(oso_plugin_qgisDialog, self).__init__(parent)
        # Set up the user interface from Designer through FORM_CLASS.
        # After self.setupUi() you can access any designer object by doing
        # self.<objectname>, and you can use autoconnect slots - see
        # http://qt-project.org/doc/qt-4.8/designer-using-a-ui-file.html
        # #widgets-and-dialogs-with-auto-connect
        self.extent = None
        self.setupUi(self)
        self.mColorButton.colorChanged.connect(self.changeColorText)
        self.mQgsFileWidget.fileChanged.connect(self.getFileName)
        self.mQgsProjectionSelectionWidget.setMessage('Select a CRS')
        self.mQgsProjectionSelectionWidget.crsChanged.connect(self.changeCrsText)
        self.mExtentGroupBox.setMapCanvas(iface.mapCanvas())
        self.mExtentGroupBox.extentChanged.connect(self.setExtent)

    def getFileName(self):
        self.label_file.setText(self.mQgsFileWidget.filePath())

    def changeColorText(self):
        self.label.setText(self.mColorButton.color().name())
        colorName = self.mColorButton.color().name()

    def changeCrsText(self):
        self.label_crs.setText(self.mQgsProjectionSelectionWidget.crs().description())

    def setExtent(self):
        self.extent = self.mExtentGroupBox.outputExtent()
        self.mExtentGroupBox.setCurrentExtent(self.extent, self.mExtentGroupBox.outputCrs())

